#ifndef STREAMER_PAD_H
#define STREAMER_PAD_H

#include <streamer/streamer.h>

struct _StreamPad {
  GMutex *mutex;

  /* what type of data is being fed through? */
  glong type;
  glong flags;

  /* who owns this pad */
  StreamElement *owner;  
  gint padnumber;

  /* who's the peer? */
  StreamPad *peer;

  /* chaining function */
  void (*chain)(StreamPad *,StreamBuffer *);
};

void StreamPad_init();
void StreamPad_connect(StreamPad *out,StreamPad *in);
void StreamPad_chain(StreamPad *pad,StreamBuffer *buf);
void StreamPad_push(StreamElement *element);

#endif /* STREAMER_PAD_H */

